diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/examples/reference/bianchi11ax.py ns-3.40/src/wifi/examples/reference/bianchi11ax.py
--- ns-3.39/src/wifi/examples/reference/bianchi11ax.py	2023-07-05 14:23:48.105428500 -0700
+++ ns-3.40/src/wifi/examples/reference/bianchi11ax.py	2023-09-27 13:30:37.898839700 -0700
@@ -129,41 +129,39 @@
 k = 1
 
 difs = 1
-fo = open("bianchi_11ax_difs.txt", "w")
-for i in range(len(data_rates_20MHz)):
-    bianchi_result = bianchi_ax(data_rates_20MHz[i], ack_rates_20MHz[i], k, difs)
-    str_s = str_result(bianchi_result, i, 20)
-    fo.write(str_s)
-for i in range(len(data_rates_40MHz)):
-    bianchi_result = bianchi_ax(data_rates_40MHz[i], ack_rates_40MHz[i], k, difs)
-    str_s = str_result(bianchi_result, i, 40)
-    fo.write(str_s)
-for i in range(len(data_rates_80MHz)):
-    bianchi_result = bianchi_ax(data_rates_80MHz[i], ack_rates_80MHz[i], k, difs)
-    str_s = str_result(bianchi_result, i, 80)
-    fo.write(str_s)
-for i in range(len(data_rates_160MHz)):
-    bianchi_result = bianchi_ax(data_rates_160MHz[i], ack_rates_160MHz[i], k, difs)
-    str_s = str_result(bianchi_result, i, 160)
-    fo.write(str_s)
-fo.close()
+with open("bianchi_11ax_difs.txt", "w", encoding="utf-8") as fo:
+    for i in range(len(data_rates_20MHz)):
+        bianchi_result = bianchi_ax(data_rates_20MHz[i], ack_rates_20MHz[i], k, difs)
+        str_s = str_result(bianchi_result, i, 20)
+        fo.write(str_s)
+    for i in range(len(data_rates_40MHz)):
+        bianchi_result = bianchi_ax(data_rates_40MHz[i], ack_rates_40MHz[i], k, difs)
+        str_s = str_result(bianchi_result, i, 40)
+        fo.write(str_s)
+    for i in range(len(data_rates_80MHz)):
+        bianchi_result = bianchi_ax(data_rates_80MHz[i], ack_rates_80MHz[i], k, difs)
+        str_s = str_result(bianchi_result, i, 80)
+        fo.write(str_s)
+    for i in range(len(data_rates_160MHz)):
+        bianchi_result = bianchi_ax(data_rates_160MHz[i], ack_rates_160MHz[i], k, difs)
+        str_s = str_result(bianchi_result, i, 160)
+        fo.write(str_s)
 
 difs = 0
-fo = open("bianchi_11ax_eifs.txt", "w")
-for i in range(len(data_rates_20MHz)):
-    bianchi_result = bianchi_ax(data_rates_20MHz[i], ack_rates_20MHz[i], k, difs)
-    str_s = str_result(bianchi_result, i, 20)
-    fo.write(str_s)
-for i in range(len(data_rates_40MHz)):
-    bianchi_result = bianchi_ax(data_rates_40MHz[i], ack_rates_40MHz[i], k, difs)
-    str_s = str_result(bianchi_result, i, 40)
-    fo.write(str_s)
-for i in range(len(data_rates_80MHz)):
-    bianchi_result = bianchi_ax(data_rates_80MHz[i], ack_rates_80MHz[i], k, difs)
-    str_s = str_result(bianchi_result, i, 80)
-    fo.write(str_s)
-for i in range(len(data_rates_160MHz)):
-    bianchi_result = bianchi_ax(data_rates_160MHz[i], ack_rates_160MHz[i], k, difs)
-    str_s = str_result(bianchi_result, i, 160)
-    fo.write(str_s)
-fo.close()
+with open("bianchi_11ax_eifs.txt", "w", encoding="utf-8") as fo:
+    for i in range(len(data_rates_20MHz)):
+        bianchi_result = bianchi_ax(data_rates_20MHz[i], ack_rates_20MHz[i], k, difs)
+        str_s = str_result(bianchi_result, i, 20)
+        fo.write(str_s)
+    for i in range(len(data_rates_40MHz)):
+        bianchi_result = bianchi_ax(data_rates_40MHz[i], ack_rates_40MHz[i], k, difs)
+        str_s = str_result(bianchi_result, i, 40)
+        fo.write(str_s)
+    for i in range(len(data_rates_80MHz)):
+        bianchi_result = bianchi_ax(data_rates_80MHz[i], ack_rates_80MHz[i], k, difs)
+        str_s = str_result(bianchi_result, i, 80)
+        fo.write(str_s)
+    for i in range(len(data_rates_160MHz)):
+        bianchi_result = bianchi_ax(data_rates_160MHz[i], ack_rates_160MHz[i], k, difs)
+        str_s = str_result(bianchi_result, i, 160)
+        fo.write(str_s)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/examples/wifi-manager-example.cc ns-3.40/src/wifi/examples/wifi-manager-example.cc
--- ns-3.39/src/wifi/examples/wifi-manager-example.cc	2023-07-05 14:23:48.105428500 -0700
+++ ns-3.40/src/wifi/examples/wifi-manager-example.cc	2023-09-27 13:30:37.898839700 -0700
@@ -211,7 +211,7 @@
     double stepSize = 1;        // dBm
     double stepTime = 1;        // seconds
     uint32_t packetSize = 1024; // bytes
-    bool broadcast = 0;
+    bool broadcast = false;
     int ap1_x = 0;
     int ap1_y = 0;
     int sta1_x = 5;
@@ -714,8 +714,8 @@
     Ptr<WifiNetDevice> wndServer = ndServer->GetObject<WifiNetDevice>();
     Ptr<WifiPhy> wifiPhyPtrClient = wndClient->GetPhy();
     Ptr<WifiPhy> wifiPhyPtrServer = wndServer->GetPhy();
-    uint8_t t_clientNss = static_cast<uint8_t>(clientNss);
-    uint8_t t_serverNss = static_cast<uint8_t>(serverNss);
+    auto t_clientNss = static_cast<uint8_t>(clientNss);
+    auto t_serverNss = static_cast<uint8_t>(serverNss);
     wifiPhyPtrClient->SetNumberOfAntennas(t_clientNss);
     wifiPhyPtrClient->SetMaxSupportedTxSpatialStreams(t_clientNss);
     wifiPhyPtrClient->SetMaxSupportedRxSpatialStreams(t_clientNss);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/helper/athstats-helper.cc ns-3.40/src/wifi/helper/athstats-helper.cc
--- ns-3.39/src/wifi/helper/athstats-helper.cc	2023-07-05 14:23:48.105428500 -0700
+++ ns-3.40/src/wifi/helper/athstats-helper.cc	2023-09-27 13:30:37.898839700 -0700
@@ -30,6 +30,7 @@
 
 #include <fstream>
 #include <iomanip>
+#include <sstream>
 
 namespace ns3
 {
@@ -87,7 +88,7 @@
 void
 AthstatsHelper::EnableAthstats(std::string filename, NetDeviceContainer d)
 {
-    for (NetDeviceContainer::Iterator i = d.Begin(); i != d.End(); ++i)
+    for (auto i = d.Begin(); i != d.End(); ++i)
     {
         Ptr<NetDevice> dev = *i;
         EnableAthstats(filename, dev->GetNode()->GetId(), dev->GetIfIndex());
@@ -98,7 +99,7 @@
 AthstatsHelper::EnableAthstats(std::string filename, NodeContainer n)
 {
     NetDeviceContainer devs;
-    for (NodeContainer::Iterator i = n.Begin(); i != n.End(); ++i)
+    for (auto i = n.Begin(); i != n.End(); ++i)
     {
         Ptr<Node> node = *i;
         for (std::size_t j = 0; j < node->GetNDevices(); ++j)
@@ -286,36 +287,36 @@
 AthstatsWifiTraceSink::WriteStats()
 {
     NS_LOG_FUNCTION(this);
-    // The comments below refer to how each value maps to madwifi's athstats
-    // I know C strings are ugly but that's the quickest way to use exactly the same format as in
-    // madwifi
-    char str[200];
-    snprintf(
-        str,
-        200,
-        "%8u %8u %7u %7u %7u %6u %6u %6u %7u %4u %3uM\n",
-        (unsigned int)m_txCount, // /proc/net/dev transmitted packets to which we should subtract
-                                 // management frames
-        (unsigned int)
-            m_rxCount,   // /proc/net/dev received packets but subtracts management frames from it
-        (unsigned int)0, // ast_tx_altrate
-        (unsigned int)m_shortRetryCount,    // ast_tx_shortretry
-        (unsigned int)m_longRetryCount,     // ast_tx_longretry
-        (unsigned int)m_exceededRetryCount, // ast_tx_xretries
-        (unsigned int)m_phyRxErrorCount,    // ast_rx_crcerr
-        (unsigned int)0,                    // ast_rx_badcrypt
-        (unsigned int)0,                    // ast_rx_phyerr
-        (unsigned int)0,                    // ast_rx_rssi
-        (unsigned int)0                     // rate
-    );
 
-    if (m_writer)
+    if (!m_writer)
     {
-        *m_writer << str;
-
-        ResetCounters();
-        Simulator::Schedule(m_interval, &AthstatsWifiTraceSink::WriteStats, this);
+        return;
     }
+
+    // The comments below refer to how each value maps to madwifi's athstats.
+    // Format: "%8lu %8lu %7u %7u %7u %6u %6u %6u %7u %4u %3uM"
+    std::stringstream ss;
+
+    // /proc/net/dev transmitted packets to which we should subtract management frames
+    ss << std::setw(8) << m_txCount << " ";
+
+    // /proc/net/dev received packets but subtracts management frames from it
+    ss << std::setw(8) << m_rxCount << " ";
+
+    ss << std::setw(7) << 0 << " ";                    // ast_tx_altrate
+    ss << std::setw(7) << m_shortRetryCount << " ";    // ast_tx_shortretry
+    ss << std::setw(7) << m_longRetryCount << " ";     // ast_tx_longretry
+    ss << std::setw(6) << m_exceededRetryCount << " "; // ast_tx_xretries
+    ss << std::setw(6) << m_phyRxErrorCount << " ";    // ast_rx_crcerr
+    ss << std::setw(6) << 0 << " ";                    // ast_rx_badcrypt
+    ss << std::setw(7) << 0 << " ";                    // ast_rx_phyerr
+    ss << std::setw(4) << 0 << " ";                    // ast_rx_rssi
+    ss << std::setw(3) << 0 << "M";                    // rate
+
+    *m_writer << ss.str() << std::endl;
+
+    ResetCounters();
+    Simulator::Schedule(m_interval, &AthstatsWifiTraceSink::WriteStats, this);
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/helper/spectrum-wifi-helper.cc ns-3.40/src/wifi/helper/spectrum-wifi-helper.cc
--- ns-3.39/src/wifi/helper/spectrum-wifi-helper.cc	2023-07-05 14:23:48.105428500 -0700
+++ ns-3.40/src/wifi/helper/spectrum-wifi-helper.cc	2023-09-27 13:30:37.898839700 -0700
@@ -42,8 +42,8 @@
 SpectrumWifiPhyHelper::SpectrumWifiPhyHelper(uint8_t nLinks)
     : WifiPhyHelper(nLinks)
 {
-    NS_ABORT_IF(m_phy.size() != nLinks);
-    for (auto& phy : m_phy)
+    NS_ABORT_IF(m_phys.size() != nLinks);
+    for (auto& phy : m_phys)
     {
         phy.SetTypeId("ns3::SpectrumWifiPhy");
     }
@@ -54,16 +54,13 @@
 void
 SpectrumWifiPhyHelper::SetChannel(const Ptr<SpectrumChannel> channel)
 {
-    m_channels[WHOLE_WIFI_SPECTRUM] = channel;
-    AddWifiBandwidthFilter(channel);
+    AddChannel(channel);
 }
 
 void
 SpectrumWifiPhyHelper::SetChannel(const std::string& channelName)
 {
-    Ptr<SpectrumChannel> channel = Names::Find<SpectrumChannel>(channelName);
-    m_channels[WHOLE_WIFI_SPECTRUM] = channel;
-    AddWifiBandwidthFilter(channel);
+    AddChannel(channelName);
 }
 
 void
@@ -79,7 +76,6 @@
 {
     Ptr<SpectrumChannel> channel = Names::Find<SpectrumChannel>(channelName);
     AddChannel(channel, freqRange);
-    AddWifiBandwidthFilter(channel);
 }
 
 void
@@ -108,17 +104,36 @@
     }
 }
 
+void
+SpectrumWifiPhyHelper::AddPhyToFreqRangeMapping(uint8_t linkId, const FrequencyRange& freqRange)
+{
+    if (auto it = m_interfacesMap.find(linkId); it == m_interfacesMap.end())
+    {
+        m_interfacesMap.insert({linkId, {freqRange}});
+    }
+    else
+    {
+        it->second.emplace(freqRange);
+    }
+}
+
+void
+SpectrumWifiPhyHelper::ResetPhyToFreqRangeMapping()
+{
+    m_interfacesMap.clear();
+}
+
 std::vector<Ptr<WifiPhy>>
 SpectrumWifiPhyHelper::Create(Ptr<Node> node, Ptr<WifiNetDevice> device) const
 {
     std::vector<Ptr<WifiPhy>> ret;
 
-    for (std::size_t i = 0; i < m_phy.size(); i++)
+    for (std::size_t i = 0; i < m_phys.size(); i++)
     {
-        Ptr<SpectrumWifiPhy> phy = m_phy.at(i).Create<SpectrumWifiPhy>();
+        auto phy = m_phys.at(i).Create<SpectrumWifiPhy>();
         auto interference = m_interferenceHelper.Create<InterferenceHelper>();
         phy->SetInterferenceHelper(interference);
-        Ptr<ErrorRateModel> error = m_errorRateModel.at(i).Create<ErrorRateModel>();
+        auto error = m_errorRateModel.at(i).Create<ErrorRateModel>();
         phy->SetErrorRateModel(error);
         if (m_frameCaptureModel.at(i).IsTypeIdSet())
         {
@@ -131,10 +146,9 @@
                 m_preambleDetectionModel.at(i).Create<PreambleDetectionModel>();
             phy->SetPreambleDetectionModel(preambleDetection);
         }
-        for (const auto& [freqRange, channel] : m_channels)
-        {
-            phy->AddChannel(channel, freqRange);
-        }
+        InstallPhyInterfaces(i, phy);
+        phy->SetChannelSwitchedCallback(
+            MakeCallback(&SpectrumWifiPhyHelper::SpectrumChannelSwitched, this).Bind(phy));
         phy->SetDevice(device);
         phy->SetMobility(node->GetObject<MobilityModel>());
         ret.emplace_back(phy);
@@ -143,4 +157,52 @@
     return ret;
 }
 
+void
+SpectrumWifiPhyHelper::InstallPhyInterfaces(uint8_t linkId, Ptr<SpectrumWifiPhy> phy) const
+{
+    if (m_interfacesMap.count(linkId) == 0)
+    {
+        // default setup: set all interfaces to this link
+        for (const auto& [freqRange, channel] : m_channels)
+        {
+            phy->AddChannel(channel, freqRange);
+        }
+    }
+    else
+    {
+        for (const auto& freqRange : m_interfacesMap.at(linkId))
+        {
+            phy->AddChannel(m_channels.at(freqRange), freqRange);
+        }
+    }
+}
+
+void
+SpectrumWifiPhyHelper::SpectrumChannelSwitched(Ptr<SpectrumWifiPhy> phy) const
+{
+    NS_LOG_FUNCTION(this << phy);
+    for (const auto& otherPhy : phy->GetDevice()->GetPhys())
+    {
+        auto spectrumPhy = DynamicCast<SpectrumWifiPhy>(otherPhy);
+        NS_ASSERT(spectrumPhy);
+        if (spectrumPhy == phy)
+        {
+            // this is the PHY that has switched
+            continue;
+        }
+        if (spectrumPhy->GetCurrentFrequencyRange() == phy->GetCurrentFrequencyRange())
+        {
+            // this is the active interface
+            continue;
+        }
+        if (const auto& interfaces = spectrumPhy->GetSpectrumPhyInterfaces();
+            interfaces.count(phy->GetCurrentFrequencyRange()) == 0)
+        {
+            // no interface attached to that channel
+            continue;
+        }
+        spectrumPhy->ConfigureInterface(phy->GetFrequency(), phy->GetChannelWidth());
+    }
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/helper/spectrum-wifi-helper.h ns-3.40/src/wifi/helper/spectrum-wifi-helper.h
--- ns-3.39/src/wifi/helper/spectrum-wifi-helper.h	2023-07-05 14:23:48.105428500 -0700
+++ ns-3.40/src/wifi/helper/spectrum-wifi-helper.h	2023-09-27 13:30:37.898839700 -0700
@@ -22,10 +22,14 @@
 
 #include "wifi-helper.h"
 
+#include <map>
+#include <set>
+
 namespace ns3
 {
 
 class SpectrumChannel;
+class SpectrumWifiPhy;
 
 /**
  * \brief Make it easy to create and manage PHY objects for the spectrum model.
@@ -81,6 +85,21 @@
     void AddChannel(const std::string& channelName,
                     const FrequencyRange& freqRange = WHOLE_WIFI_SPECTRUM);
 
+    /**
+     * Add a given spectrum PHY interface to the PHY instance corresponding of a given link.
+     * If no mapping has been specified for a given link, all spectrum PHY interfaces will
+     * be added to the PHY instance of that link.
+     *
+     * \param linkId ID of the link to setup
+     * \param freqRange frequency range handled by of the spectrum PHY interface
+     */
+    void AddPhyToFreqRangeMapping(uint8_t linkId, const FrequencyRange& freqRange);
+
+    /**
+     * Reset mapping of the spectrum PHY interfaces added to the PHY instances.
+     */
+    void ResetPhyToFreqRangeMapping();
+
   private:
     /**
      * \param node the node on which we wish to create a wifi PHY
@@ -90,6 +109,22 @@
      * This method implements the pure virtual method defined in \ref ns3::WifiPhyHelper.
      */
     std::vector<Ptr<WifiPhy>> Create(Ptr<Node> node, Ptr<WifiNetDevice> device) const override;
+
+    /**
+     * \brief Install PHY interfaces to the PHY instance of a given link
+     * based on the currently configured mapping (\see AddPhyInterface).
+     *
+     * \param linkId ID of the link to setup
+     * \param phy spectrum PHY instance of the link
+     */
+    void InstallPhyInterfaces(uint8_t linkId, Ptr<SpectrumWifiPhy> phy) const;
+
+    /**
+     * Function that is notified when a spectrum channel switched
+     * \param phy spectrum PHY instance that has switched its channel
+     */
+    void SpectrumChannelSwitched(Ptr<SpectrumWifiPhy> phy) const;
+
     /**
      * \param channel The channel to inspect to possibly add a WifiBandwidthFilter
      *
@@ -99,6 +134,9 @@
     void AddWifiBandwidthFilter(Ptr<SpectrumChannel> channel);
 
     std::map<FrequencyRange, Ptr<SpectrumChannel>> m_channels; ///< the spectrum channels
+    std::map<uint8_t /* linkId */, std::set<FrequencyRange>>
+        m_interfacesMap; ///< map of the spectrum PHY interfaces to be added to the PHY instance
+                         ///< corresponding to a given link ID
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/helper/wifi-helper.cc ns-3.40/src/wifi/helper/wifi-helper.cc
--- ns-3.39/src/wifi/helper/wifi-helper.cc	2023-07-05 14:23:48.105428500 -0700
+++ ns-3.40/src/wifi/helper/wifi-helper.cc	2023-09-27 13:30:37.898839700 -0700
@@ -147,7 +147,7 @@
     : m_pcapDlt(PcapHelper::DLT_IEEE802_11)
 {
     NS_ABORT_IF(nLinks == 0);
-    m_phy.resize(nLinks);
+    m_phys.resize(nLinks);
     m_errorRateModel.resize(nLinks);
     m_frameCaptureModel.resize(nLinks);
     m_preambleDetectionModel.resize(nLinks);
@@ -162,7 +162,7 @@
 void
 WifiPhyHelper::Set(std::string name, const AttributeValue& v)
 {
-    for (auto& phy : m_phy)
+    for (auto& phy : m_phys)
     {
         phy.Set(name, v);
     }
@@ -171,7 +171,7 @@
 void
 WifiPhyHelper::Set(uint8_t linkId, std::string name, const AttributeValue& v)
 {
-    m_phy.at(linkId).Set(name, v);
+    m_phys.at(linkId).Set(name, v);
 }
 
 void
@@ -759,7 +759,7 @@
                     NodeContainer::Iterator last) const
 {
     NetDeviceContainer devices;
-    for (NodeContainer::Iterator i = first; i != last; ++i)
+    for (auto i = first; i != last; ++i)
     {
         Ptr<Node> node = *i;
         Ptr<WifiNetDevice> device = CreateObject<WifiNetDevice>();
@@ -975,6 +975,11 @@
     LogComponentEnable("YansWifiChannel", LOG_LEVEL_ALL);
     LogComponentEnable("YansWifiPhy", LOG_LEVEL_ALL);
 
+    LogComponentEnable("Athstats", LOG_LEVEL_ALL);
+    LogComponentEnable("WifiHelper", LOG_LEVEL_ALL);
+    LogComponentEnable("SpectrumWifiHelper", LOG_LEVEL_ALL);
+    LogComponentEnable("YansWifiHelper", LOG_LEVEL_ALL);
+
     // From Spectrum
     LogComponentEnable("WifiSpectrumValueHelper", LOG_LEVEL_ALL);
 }
@@ -984,7 +989,7 @@
 {
     int64_t currentStream = stream;
     Ptr<NetDevice> netDevice;
-    for (NetDeviceContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         netDevice = (*i);
         Ptr<WifiNetDevice> wifi = DynamicCast<WifiNetDevice>(netDevice);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/helper/wifi-helper.h ns-3.40/src/wifi/helper/wifi-helper.h
--- ns-3.39/src/wifi/helper/wifi-helper.h	2023-07-05 14:23:48.105428500 -0700
+++ ns-3.40/src/wifi/helper/wifi-helper.h	2023-09-27 13:30:37.898839700 -0700
@@ -235,7 +235,7 @@
                                  SignalNoiseDbm signalNoise,
                                  uint16_t staId = SU_STA_ID);
 
-    std::vector<ObjectFactory> m_phy;                    ///< PHY object
+    std::vector<ObjectFactory> m_phys;                   ///< PHY objects
     ObjectFactory m_interferenceHelper;                  ///< interference helper
     std::vector<ObjectFactory> m_errorRateModel;         ///< error rate model
     std::vector<ObjectFactory> m_frameCaptureModel;      ///< frame capture model
@@ -549,7 +549,7 @@
 void
 WifiPhyHelper::SetErrorRateModel(std::string type, Args&&... args)
 {
-    for (std::size_t linkId = 0; linkId < m_phy.size(); linkId++)
+    for (std::size_t linkId = 0; linkId < m_phys.size(); linkId++)
     {
         SetErrorRateModel(linkId, type, std::forward<Args>(args)...);
     }
@@ -567,7 +567,7 @@
 void
 WifiPhyHelper::SetFrameCaptureModel(std::string type, Args&&... args)
 {
-    for (std::size_t linkId = 0; linkId < m_phy.size(); linkId++)
+    for (std::size_t linkId = 0; linkId < m_phys.size(); linkId++)
     {
         SetFrameCaptureModel(linkId, type, std::forward<Args>(args)...);
     }
@@ -585,7 +585,7 @@
 void
 WifiPhyHelper::SetPreambleDetectionModel(std::string type, Args&&... args)
 {
-    for (std::size_t linkId = 0; linkId < m_phy.size(); linkId++)
+    for (std::size_t linkId = 0; linkId < m_phys.size(); linkId++)
     {
         SetPreambleDetectionModel(linkId, type, std::forward<Args>(args)...);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/helper/yans-wifi-helper.cc ns-3.40/src/wifi/helper/yans-wifi-helper.cc
--- ns-3.39/src/wifi/helper/yans-wifi-helper.cc	2023-07-05 14:23:48.105428500 -0700
+++ ns-3.40/src/wifi/helper/yans-wifi-helper.cc	2023-09-27 13:30:37.898839700 -0700
@@ -54,9 +54,7 @@
 {
     Ptr<YansWifiChannel> channel = CreateObject<YansWifiChannel>();
     Ptr<PropagationLossModel> prev = nullptr;
-    for (std::vector<ObjectFactory>::const_iterator i = m_propagationLoss.begin();
-         i != m_propagationLoss.end();
-         ++i)
+    for (auto i = m_propagationLoss.begin(); i != m_propagationLoss.end(); ++i)
     {
         Ptr<PropagationLossModel> cur = (*i).Create<PropagationLossModel>();
         if (prev)
@@ -84,7 +82,7 @@
     : WifiPhyHelper(1), // YANS phy is not used for 11be devices
       m_channel(nullptr)
 {
-    m_phy.at(0).SetTypeId("ns3::YansWifiPhy");
+    m_phys.front().SetTypeId("ns3::YansWifiPhy");
     SetInterferenceHelper("ns3::InterferenceHelper");
     SetErrorRateModel("ns3::TableBasedErrorRateModel");
 }
@@ -105,19 +103,19 @@
 std::vector<Ptr<WifiPhy>>
 YansWifiPhyHelper::Create(Ptr<Node> node, Ptr<WifiNetDevice> device) const
 {
-    Ptr<YansWifiPhy> phy = m_phy.at(0).Create<YansWifiPhy>();
+    Ptr<YansWifiPhy> phy = m_phys.front().Create<YansWifiPhy>();
     Ptr<InterferenceHelper> interference = m_interferenceHelper.Create<InterferenceHelper>();
     phy->SetInterferenceHelper(interference);
-    Ptr<ErrorRateModel> error = m_errorRateModel.at(0).Create<ErrorRateModel>();
+    Ptr<ErrorRateModel> error = m_errorRateModel.front().Create<ErrorRateModel>();
     phy->SetErrorRateModel(error);
-    if (m_frameCaptureModel.at(0).IsTypeIdSet())
+    if (m_frameCaptureModel.front().IsTypeIdSet())
     {
-        auto frameCapture = m_frameCaptureModel.at(0).Create<FrameCaptureModel>();
+        auto frameCapture = m_frameCaptureModel.front().Create<FrameCaptureModel>();
         phy->SetFrameCaptureModel(frameCapture);
     }
-    if (m_preambleDetectionModel.at(0).IsTypeIdSet())
+    if (m_preambleDetectionModel.front().IsTypeIdSet())
     {
-        auto preambleDetection = m_preambleDetectionModel.at(0).Create<PreambleDetectionModel>();
+        auto preambleDetection = m_preambleDetectionModel.front().Create<PreambleDetectionModel>();
         phy->SetPreambleDetectionModel(preambleDetection);
     }
     phy->SetChannel(m_channel);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/ampdu-subframe-header.cc ns-3.40/src/wifi/model/ampdu-subframe-header.cc
--- ns-3.39/src/wifi/model/ampdu-subframe-header.cc	2023-07-05 14:23:48.109428400 -0700
+++ ns-3.40/src/wifi/model/ampdu-subframe-header.cc	2023-09-27 13:30:37.902840000 -0700
@@ -44,7 +44,7 @@
 
 AmpduSubframeHeader::AmpduSubframeHeader()
     : m_length(0),
-      m_eof(0),
+      m_eof(false),
       m_signature(0x4E) // Per 802.11 standard, the unique pattern is set to the value 0x4E.
 {
 }
